<?php
# DeKernel Multibyte and addon functions
# v.3.3

function utf8_substr($str, $offset, $length = null)
{
#в начале пробуем найти стандартные функции
if (function_exists('iconv_substr')) return iconv_substr($str, $offset, $length, 'utf-8'); #(PHP 5)
if (function_exists('mb_substr')) return mb_substr($str, $offset, $length, 'utf-8'); #(PHP 4 >= 4.0.6, PHP 5)
#однократные паттерны повышают производительность!
preg_match_all('/(?>[\x09\x0A\x0D\x20-\x7E]           # ASCII
| [\xC2-\xDF][\x80-\xBF]            # non-overlong 2-byte
|  \xE0[\xA0-\xBF][\x80-\xBF]       # excluding overlongs
| [\xE1-\xEC\xEE\xEF][\x80-\xBF]{2} # straight 3-byte
|  \xED[\x80-\x9F][\x80-\xBF]       # excluding surrogates
|  \xF0[\x90-\xBF][\x80-\xBF]{2}    # planes 1-3
| [\xF1-\xF3][\x80-\xBF]{3}         # planes 4-15
|  \xF4[\x80-\x8F][\x80-\xBF]{2}    # plane 16
)
/xs', $str, $m);
if ($length !== null) $a = array_slice($m[0], $offset, $length);
else $a = array_slice($m[0], $offset);
return implode('', $a);
}

function utf8_strlen($str)
{
if (function_exists('mb_strlen')) return mb_strlen($str, 'utf-8');
if (function_exists('iconv_strlen')) return iconv_strlen($str, 'utf-8');
#utf8_decode() converts characters that are not in ISO-8859-1 to '?', which, for the purpose of counting, is quite alright.
return strlen(utf8_decode($str));
}
############################ BB-коды ############################
function BBcode($str)
{
$str = preg_replace("#\[link=(.*?)\](.*?)\[/link\]#si", "<a href=\"\\1\">\\2</a>", $str);
$str = preg_replace("#\[url=(.*?)\](.*?)\[/url\]#si", "<a href=\"\\1\">\\2</a>", $str);
$str = preg_replace("#\[img=(.*?)\](.*?)\[/img\]#si", "<img src=\"\\1\" alt=\"\\2\"/>", $str);
$str = preg_replace("#\[red\](.*?)\[/red\]#si", "<span style=\"color: red\">\\1</span>", $str);
$str = preg_replace("#\[blue\](.*?)\[/blue\]#si", "<span style=\"color: blue\">\\1</span>", $str);
$str = preg_replace("#\[black\](.*?)\[/black\]#si", "<span style=\"color: black\">\\1</span>", $str);
$str = preg_replace("#\[white\](.*?)\[/white\]#si", "<span style=\"color: white\">\\1</span>", $str);
$str = preg_replace("#\[green\](.*?)\[/green\]#si", "<span style=\"color: green\">\\1</span>", $str);
$str = preg_replace("#\[orange\](.*?)\[/orange\]#si", "<span style=\"color: orange\">\\1</span>", $str);
$str = preg_replace("#\[pink\](.*?)\[/pink\]#si", "<span style=\"color: pink\">\\1</span>", $str);
$str = preg_replace("#\[gray\](.*?)\[/gray\]#si", "<span style=\"color: gray\">\\1</span>", $str);
$str = preg_replace("#\[big\](.*?)\[/big\]#si", "<span style=\"font-size: 20px\">\\1</span>", $str);
$str = preg_replace("#\[small\](.*?)\[/small\]#si", "<span style=\"font-size: 8px\">\\1</span>", $str);
$str = preg_replace("#\[cod\](.*?)\[/cod\]#si", "<div class=\"d\"><span style=\"color: #000000\">\\1</span></div>", $str);
$str = preg_replace("#\[b\](.*?)\[/b\]#si", "<b>\\1</b>", $str);
$str = preg_replace("#\[u\](.*?)\[/u\]#si", "<u>\\1</u>", $str);
$str = preg_replace("#\[i\](.*?)\[/i\]#si", "<i>\\1</i>", $str);
$str = preg_replace("#\[li\](.*?)\[/li\]#si", "<ul><li>\\1</li></ul>", $str);
$str = preg_replace("#\[strike\](.*?)\[/strike\]#si", "<strike>\\1</strike>", $str);
return nl2br($str);
}
?>